﻿
namespace SignorityAPI
{
    public class Tag
    {
        public int id { get; set; }
        public string name { get; set; }
        public int? invitationId { get; set; }
        public int pageId { get; set; }

        public bool isMandatory { get; set; }

        public int type { get; set; }
        public int top { get; set; }
        public int left { get; set; }
        public int height { get; set; }
        public int width { get; set; }
        public bool valueSelected { get; set; }
        public string style { get; set; }

        public string textValue { get; set; }
        public string imageDataValue { get; set; }
        
       // from 1 to number of pages
        public int? pageIndex { get; set; }
        // from 1 to number of signers
        public int? invitationIndex { get; set; }

        // from 1 to number of hosted signers under a specific signer
        public int? hostedSignerIndex { get; set; }

        public void setType(string type, string defaultvalue = "")
        {
            this.width = 107;
            this.height = 35;

            if (type == Code.TAG_SIGN)
            {
                this.type = 250;
                this.style = "{\"font-size\":\"12pt\"}";
                this.width = 107;
                this.height = 35;
            } else if (type == Code.TAG_DATE)
            {
                this.type = 255;
                this.style = "{\"font-size\":\"12pt\",\"dateFormat\":\"MM / DD / YYYY\"}";
            } else if (type == Code.TAG_TEXT)
            {
                this.type = 252;
                this.textValue = defaultvalue;
                this.style = "{\"font-size\":\"12pt\"}";
            } else if (type == Code.TAG_CHECKBOX)
            {
                this.type = 253;
                this.style = "{\"font-size\":\"12pt\"}";
            } else if (type == Code.TAG_RADIO)
            {
                this.type = 254;
                this.style = "{\"font-size\":\"12pt\"}";
            } else
            {
                this.type = 258;
                this.style = "{\"font-size\":\"12pt\"}";
            }  
        }
        /*
         * type : tag type
         * name : tag name
         * page_index : where the tag goes, from 1 to number of pages
         * invitaion_index : who the tag is for,  from 1 to number of signers
         * left : tag's position.x
         * top : tag's position.y
         * isMandatory : required 
         * hostedSignerIndex : from 1 to number of hosted signers under a specific signer
         */
        public void setTag(string type,string name, int page_index, int invitaion_index, int left, int top, bool isMandatory, string defaultvalue="", int hostedSignerIndex = 0)
        {
            this.setType(type, defaultvalue);
            this.name = name;
            this.pageIndex = page_index;
            this.invitationIndex = invitaion_index;
            this.left = left;
            this.top = top;
            this.isMandatory = isMandatory;
            this.hostedSignerIndex = hostedSignerIndex;
        }
    }
}
